#!/usr/bin/perl -w

################################################################################
#
# cid_html.pl
# Author: Suraj K. Rai (surajrai@yahoo.com)
# Date:   03/01/2000
# Version: 0.1
#
# The program takes an input file $cidLogFile and generates a formatted
# HTML output file ready for the web.  The generated page has capability of
# filtering/sorting data.
#
################################################################################

use CGI;

# I used these modules for filtering purposes...I know it is very slow
# if you know of any faster date/time processing modules in Perl let me know.
use DateTime::Precise;
use Date::Manip;

# Log file where all the cid data is stored
# format of file is date,name,phone
$cidLogFile="/usr/local/etc/cid-log";

# Sort Parameters => 0 - Date, 1 - Name, 2 - Phone No.
$sortBy=0;

# Order Parameters => 0 - Up, 1 - Down;
$order=0;

# Filter Parametrs
$filterByDate="";
$filterByName="";
$filterByPhone="";

# HTML variables
$tableWidth = 600;

# The userinfo table...I know, I know this sucks balls but..
# I will eventually move it a file based system once I get the time.
# The has is used to say welcome to the user....assuming that you
# set up some authentication scheme with Apache .htaccess
%userInfo = 
(
 srai => 'Suraj K. Rai',
);

# Debug
$DEBUG = 0;

sub ReadCGIParam()
{
    my $query = new CGI();

    if( defined $query->param('sortBy') ) {
        $sortBy = $query->param('sortBy');
    }

    if( defined $query->param('order') ) {
        $order = $query->param('order');
    }

    if( defined $query->param('filterByDate') ) {
        $filterByDate  = $query->param('filterByDate');
    }
    
    if( defined $query->param('filterByName') ) {
        $filterByName  = $query->param('filterByName');
    }
    
    if( defined $query->param('filterByPhone') ) {
        $filterByPhone = $query->param('filterByPhone');
    }

    if( $DEBUG )
    {
        foreach $key ($query->param) {
            print "<STRONG>$key</STRONG> -> ";
            @values = $query->param($key);
            print join(", ",@values),"<BR>\n";
        }

        print "<STRONG>REMOTE_USER</STRONG>-> ", $ENV{REMOTE_USER};
    }
}

sub PrintHTMLHeader()
{
print <<END;
Content-type: text/html


<HTML>
<HEAD>
  <TITLE>cid: Caller-ID Info</TITLE>
  <SCRIPT LANGUAGE='Javascript'>
  <!--
    /*
     * Resets the filter parameters to null values so that
     * when doing a clear filter, the page comes back unfiltered.
     */

    function clearFilterParams() {
      document.filterForm.filterByDate.value  = "";
      document.filterForm.filterByName.value  = "";
      document.filterForm.filterByPhone.value = "";
    }
  // -->
  </SCRIPT>
</HEAD>

<BODY BGCOLOR='white'>
<H3>Welcome back to CID-Info $userInfo{ $ENV{REMOTE_USER} } !!!</H3>
<HR>

END
}

sub PrintHTMLFooter()
{
print <<END;

<HR>
<I>&copy 2000 <A HREF='mailto:surajrai\@yahoo.com'>surajrai\@yahoo.com</A></I>
</BODY>
</HTML>

END
}
    
# First read the file into an array so that we can pass the array around.
sub ReadCidData()
{
    my($cidData) = @_;
    my($retCode) = 0;

    if( open(LOGFILE, $cidLogFile) ) {
        while( <LOGFILE> )
        {
            chomp;
            push @$cidData, [ split /,/ ];
        }
        $retCode = 1;
    } else {
        print "Error opening cid log file.\n";
    }
    
    return($retCode);
}

################################################################################
# The filter controls are form based text input boxes. There are three of them
# for date, name and phone number.  The user is supposed to type in the entry
# they want to filter by and click on the 'Filter CID' button to filter out the
# data they want.
################################################################################
sub ShowFilterControls()
{
    my ($output) = "";

    $output .= "<FORM ACTION='/cgi-bin/cid_html.pl' NAME='filterForm' METHOD='Post'>\n" .
               "  <TR>\n" .
               "    <TD COLSPAN='3' ALIGN='Center'>\n" .
               "      <INPUT TYPE='SUBMIT' NAME='Filter' VALUE='Filter CID'>\n" .
               "      <INPUT TYPE='SUBMIT' NAME='Clear'  VALUE='Clear Filter' onClick='clearFilterParams()'>\n" .
               "    </TD>\n" .
               "  </TR>\n" .
               "  <TR>\n" .
               "    <TD ALIGN='Center'><INPUT TYPE='TEXT' NAME='filterByDate' VALUE='$filterByDate' SIZE=20></TD>\n" .
               "    <TD ALIGN='Center'><INPUT TYPE='TEXT' NAME='filterByName' VALUE='$filterByName' SIZE=20></TD>\n" .
               "    <TD ALIGN='Center'><INPUT TYPE='TEXT' NAME='filterByPhone' VALUE='$filterByPhone' SIZE=20></TD>\n" .
               "  </TR>\n" .
               "  <INPUT TYPE='Hidden' NAME='sortBy' VALUE='$sortBy'>\n" .
               "  <INPUT TYPE='Hidden' NAME='order'  VALUE='$order'>\n" .
               "</FORM>\n";

    print $output;
}

################################################################################
# The main function for printing out data data in a nice HTML table.
################################################################################
sub ShowData()
{
    my($cidData) = @_;

    my($output) = "";

    # Construct the header with the nice Up/Down button
    # I know this is horrible code ... too lazy to fix it...it works for now
    $output .= "  <TR BGCOLOR='#ff6600'>\n";
    if( $order == 0 ) { 
        $order = 1;
        $img='down';
    } else {
        $order = 0;
        $img='up';
    }
    if( $sortBy == 0 ) {
        $output .= "    <TH><A HREF='/cgi-bin/cid_html.pl?sortBy=0&order=$order" .
                   "&filterByDate=$filterByDate&filterByName=$filterByName&filterByPhone=$filterByPhone'>" .
                   "<IMG SRC='/icons/$img.gif' height=13 width=13 border=0></A>Date</TH>\n" .
                   "    <TH><A HREF='/cgi-bin/cid_html.pl?sortBy=1&order=0" .
                   "&filterByDate=$filterByDate&filterByName=$filterByName&filterByPhone=$filterByPhone'>Name</A></TH>\n" .
                   "    <TH><A HREF='/cgi-bin/cid_html.pl?sortBy=2&order=0" .
                   "&filterByDate=$filterByDate&filterByName=$filterByName&filterByPhone=$filterByPhone'>Number</A></TH>\n";
    } elsif( $sortBy == 1 ) {
        $output .= "    <TH><A HREF='/cgi-bin/cid_html.pl?sortBy=0&order=0" . 
                   "&filterByDate=$filterByDate&filterByName=$filterByName&filterByPhone=$filterByPhone'>Date</A></TH>\n" .
                   "    <TH><A HREF='/cgi-bin/cid_html.pl?sortBy=1&order=$order" . 
                   "&filterByDate=$filterByDate&filterByName=$filterByName&filterByPhone=$filterByPhone'>" .
                   "<IMG SRC='/icons/$img.gif' height=13 width=13 border=0></A>Name</TH>\n" .
                   "    <TH><A HREF='/cgi-bin/cid_html.pl?sortBy=2&order=0" .
                   "&filterByDate=$filterByDate&filterByName=$filterByName&filterByPhone=$filterByPhone'>Number</A></TH>\n";
    } else {
        $output .= "    <TH><A HREF='/cgi-bin/cid_html.pl?sortBy=0&order=0" .
                   "&filterByDate=$filterByDate&filterByName=$filterByName&filterByPhone=$filterByPhone'>Date</A></TH>\n" .
                   "    <TH><A HREF='/cgi-bin/cid_html.pl?sortBy=1&order=0" . 
                   "&filterByDate=$filterByDate&filterByName=$filterByName&filterByPhone=$filterByPhone'>Name</A></TH>\n" .
                   "    <TH><A HREF='/cgi-bin/cid_html.pl?sortBy=2&order=$order" .
                   "&filterByDate=$filterByDate&filterByName=$filterByName&filterByPhone=$filterByPhone'>" .
                   "<IMG SRC='/icons/$img.gif' height=13 width=13 border=0></A>Number</TH>\n";
    }
    $output .= "  </TR>\n";


    # Now start printing out the rows of caller id info
    my($oddEven) = 1;
    my($tempDate) = DateTime::Precise->new;
    foreach $row (@$cidData) {

        if( ($oddEven % 2) == 0 ) {
            $bgColor = '#6666cc';
        } else {
            $bgColor = '#eeeeee';
        }
        $oddEven++;

        # dates are stored as no. of seconds from epoch in file
        $tempDate->set_localtime_from_epoch_time($row->[0]);

        $output .= "  <TR BGCOLOR='$bgColor'>\n" .
                   "    <TD>" .
                   $tempDate->dprintf("%~w %~M %-D %h:%m:%s %^Y") .
                   "</TD><TD>$row->[1]</TD><TD>$row->[2]</TD>\n" .
                   "  </TR>\n";
    }

    print $output;

    # Now add a summary section
    print "  <TR BGCOLOR='#ff6600'>\n";
    print "    <TD COLSPAN=3><B>Total No. of Records: ", $#$cidData+1, "</B></TD>\n";
    print "  </TR>\n";
}

# The data gets sorted by whatever the sortBy clause is...
# However, if the data is equal to one another then the date is used
# for additional constraint.
sub SortData()
{
    if( $order ) {
        $a->[$sortBy] cmp $b->[$sortBy] or $a->[0] cmp $b->[0];
    } else {
        $b->[$sortBy] cmp $a->[$sortBy] or $b->[0] cmp $a->[0];
    }
}

################################################################################
#  The function used to filter the data out depending on the filter conditions
#  used.  Takes in the contents of the log file and spits out only the filtered
#  contents.
################################################################################
sub FilterData()
{
    my($cidData,$filteredData) = @_;
    my($matched) = 1;

    my($secs,$t1,$t2) = 0;

    if( $filterByDate ne "" ) {
        $secs = &UnixDate($filterByDate, "%s");
        $t1   = DateTime::Precise->new;
        $t1->set_localtime_from_epoch_time($secs);
        $t2 = DateTime::Precise->new;
    }

    foreach $row (@$cidData) {
        $matched = 1;

        if( $filterByDate ne "" ) {
            $t2->set_localtime_from_epoch_time($row->[0]);
            if( $t1->year != $t2->year || $t1->month != $t2->month ||
                $t1->day  != $t2->day ) {
                $matched = 0;
            }
        }

        if( $filterByName ne "" ) {
            $_ = $row->[1];
            if( !m/$filterByName/i ) {
                $matched = 0;
            }
        }

        if( $filterByPhone ne "" ) {
            $_ = $row->[2];
            if( !m/$filterByPhone/i ) {
                $matched = 0;
            }
        }

        if( $matched == 1 ) {
            push @$filteredData, [ @$row ];
        }
    }
}

sub Main()
{
    my(@cidData) = ();
    my(@filtSortData) = ();

    &PrintHTMLHeader();

    &ReadCGIParam();

    if( &ReadCidData(\@cidData) )
    {
        &FilterData(\@cidData,\@filtSortData);

        @filtSortData = sort SortData @filtSortData;
        
        print "<TABLE WIDTH='$tableWidth' CELLPADDING=0 CELLSPACING=1 BORDER=0>\n";

        &ShowFilterControls();

        &ShowData(\@filtSortData);

        print "</TABLE>\n";
    }

    &PrintHTMLFooter();
}


# start the program
&Main();
